#include <string.h>
#include <assert.h>
#include <ross.h>

#include "comb.h"
#include "mr-types.h"
#include "mr-extern.h"
#include "mr-config.h" 
#include "mr-event.h"

void 
handle_recv_block_pos_query_event( datanode_state * ns,
				   tw_bf * b,
				   mr_msg * m,
				   tw_lp * lp)
{
  /* ns->query_msg_count++; */
  /* printf(" $$$$$$ Query count now is %d\n",ns->query_msg_count); */

  tw_event *e;
  mr_msg *msg;
  tw_stime interval;
  int dest_id;

  mr_msg * m_local = malloc(sizeof(mr_msg));
  mr_msg * m_remote = malloc(sizeof(mr_msg));

  m_local->mr_event_type = MR_LOCAL;
  m_local->src = lp->gid;

  memcpy(m_remote, m_local, sizeof(mr_msg));
  m_remote->mr_event_type = MR_ACK_BLOCK_POS_QUERY;

  // send back
  dest_id = m->src;
  //dest_id = JOB_TRACKER_POS;
  /* printf("This is lp %d *** src is %d\n", */
  /* 	 lp->gid, */
  /* 	 m->src ); */
  
  // process query
  
  // if local send directly
  if (isInSameNode(lp->gid,dest_id))
    {
      e = codes_event_new(dest_id, LOCAL_MSG_TRANS_INTERVAL, lp);
      msg = tw_event_data(e);
      // process query simply
      memcpy( msg->mr_block.dnPos,
      	      (ns->nn_state)->block_map[m->mr_task.neededBlock[0]],
      	      sizeof(int) * N_REPLICA );

      msg->mr_event_type = MR_ACK_BLOCK_POS_QUERY;
      tw_event_send(e);
    }
  else// otherwise send through network
    {
      memcpy( m_remote->mr_block.dnPos,
      	      (ns->nn_state)->block_map[m->mr_task.neededBlock[0]],
      	      sizeof(int) * N_REPLICA );

      model_net_event( net_id,
      		       "test",
      		       dest_id,
      		       QUERY_MSG_SIZE,
      		       sizeof(mr_msg),
      		       (const void*)m_remote,
      		       sizeof(mr_msg),
      		       (const void*)m_local,
      		       lp );
    }
}

void
handle_get_inter_data_event( datanode_state * ns,
			     tw_bf * b,
			     mr_msg * m,
			     tw_lp * lp)
{
  printf(" \t \n This is data node %d and received ** GET INTER DATA ** request from %d, time now is %lf\n", lp->gid, m->src, tw_now(lp)); 
  tw_event *e;
  mr_msg *msg;
  tw_stime interval;
  tw_lpid dest_id = m->src;

  mr_msg * m_local = malloc(sizeof(mr_msg));
  mr_msg * m_remote = malloc(sizeof(mr_msg));

  m_local->mr_event_type = MR_LOCAL;
  m_local->src = lp->gid;

  memcpy(m_remote, m_local, sizeof(mr_msg));
  m_remote->mr_event_type = MR_GET_INTER_DATA_BACK;

  // if local send directly
  if (isInSameNode(lp->gid,dest_id))
    {
      ns->local_IO_channel_next_available_time = max( ns->local_IO_channel_next_available_time,
						  tw_now(lp));
      interval = ns->local_IO_channel_next_available_time - tw_now(lp);
      
      e = codes_event_new( dest_id, 
			   interval + BLOCK_SIZE/LOCAL_IO_BANDWDITH/NUM_TASK_PER_JOB, 
			   lp);

      ns->local_IO_channel_next_available_time +=
	BLOCK_SIZE/LOCAL_IO_BANDWDITH/NUM_TASK_PER_JOB;

      msg = tw_event_data(e);
      msg->src = lp->gid;
      msg->mr_event_type =  MR_GET_INTER_DATA_BACK;
      printf("go go go\n");
      tw_event_send(e);
    }
  else// otherwise send through network
    {
      printf("go go go 2\n");
      model_net_event( net_id,
  		       "test",
  		       dest_id,
  		       //BLOCK_SIZE/NUM_TASK_PER_JOB,
  		       204800,
		       sizeof(mr_msg),
  		       (const void*)m_remote,
  		       sizeof(mr_msg),
  		       (const void*)m_local,
  		       lp );
    }

}

void
handle_get_inter_data_event_rc( datanode_state * ns,
				tw_bf * b,
				mr_msg * m,
				tw_lp * lp)
{
  
}

void 
handle_recv_block_pos_query_event_rc( datanode_state * ns,
				      tw_bf * b,
				      mr_msg * m,
				      tw_lp * lp)
{
  
}

void 
handle_process_get_data_block_event( datanode_state * ns,
				     tw_bf * b,
				     mr_msg * m,
				     tw_lp * lp)
{
  tw_event *e;
  mr_msg *msg;
  tw_stime interval;
  int dest_id;

  printf("*** Process get data block event *** lp id is %d and now is %lf\n",lp->gid,tw_now(lp));
  ns->read_channel_next_available_time = max( ns->read_channel_next_available_time,
					      tw_now(lp));
  interval = ns->read_channel_next_available_time - tw_now(lp);

  ns->read_channel_next_available_time +=
    BLOCK_SIZE/LOCAL_IO_BANDWDITH;
  
  e = codes_event_new(m->src, interval + BLOCK_SIZE/LOCAL_IO_BANDWDITH, lp);
  //e = codes_event_new(0, interval + BLOCK_SIZE/LOCAL_IO_BANDWDITH, lp);
  msg = tw_event_data(e);
  msg->mr_event_type = MR_GET_DATA_BLOCK_BACK;
  tw_event_send(e);

}

void handle_process_get_data_block_event_rc(
    datanode_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp)
{
  
}


/* /\* handle initial event *\/ */
/* void handle_kickoff_event( */
/*     datanode_state * ns, */
/*     tw_bf * b, */
/*     mr_msg * m, */
/*     tw_lp * lp) */
/* { */
/*     mr_msg * m_local = malloc(sizeof(mr_msg)); */
/*     mr_msg * m_remote = malloc(sizeof(mr_msg)); */

/* //    m_local->mr_event_type = MR_REQ; */
/*     m_local->mr_event_type = MR_LOCAL; */
/*     m_local->src = lp->gid; */

/*     memcpy(m_remote, m_local, sizeof(mr_msg)); */
/*     m_remote->mr_event_type = MR_REQ; */
/*     //printf("handle_kickoff_event(), lp %llu.\n", (unsigned long long)lp->gid); */

/*     /\* record when transfers started on this server *\/ */
/*     ns->start_ts = tw_now(lp); */

/*     int opt_offset = 0; */
/*     if(net_id == DRAGONFLY && lp->gid % 5) */
/* 	  opt_offset = 3; /\* optional offset due to dragonfly mapping *\/ */
    
/*     /\* each server sends a request to the next highest server *\/ */
/*     int dest_id = (lp->gid + offset + opt_offset)%(num_datanode*2 + num_routers); */
/*     model_net_event(net_id, "test", dest_id, PAYLOAD_SZ, sizeof(mr_msg), (const void*)m_remote, sizeof(mr_msg), (const void*)m_local, lp); */
/*     ns->msg_sent_count++; */
/* } */

/* void handle_local_event( */
/* 		datanode_state * ns, */
/* 		tw_bf * b, */
/* 		mr_msg * m, */
/* 		tw_lp * lp) */
/* { */
/*     ns->local_recvd_count++; */
/* } */

/* void handle_local_rev_event( */
/* 	       datanode_state * ns, */
/* 	       tw_bf * b, */
/* 	       mr_msg * m, */
/* 	       tw_lp * lp) */
/* { */
/*     ns->local_recvd_count--; */
/* } */
/* /\* reverse handler for req event *\/ */
/* void handle_req_rev_event( */
/*     datanode_state * ns, */
/*     tw_bf * b, */
/*     mr_msg * m, */
/*     tw_lp * lp) */
/* { */
/*     ns->msg_recvd_count--; */
/*     model_net_event_rc(net_id, lp, PAYLOAD_SZ); */

/*     return; */
/* } */

/* /\* reverse handler for kickoff *\/ */
/* void handle_kickoff_rev_event( */
/*     datanode_state * ns, */
/*     tw_bf * b, */
/*     mr_msg * m, */
/*     tw_lp * lp) */
/* { */
/*     ns->msg_sent_count--; */
/*     model_net_event_rc(net_id, lp, PAYLOAD_SZ); */

/*     return; */
/* } */

/* /\* reverse handler for ack*\/ */
/* void handle_ack_rev_event( */
/*     datanode_state * ns, */
/*     tw_bf * b, */
/*     mr_msg * m, */
/*     tw_lp * lp) */
/* { */
/*     if(m->incremented_flag) */
/*     { */
/*         model_net_event_rc(net_id, lp, PAYLOAD_SZ); */
/*         ns->msg_sent_count--; */
/*     } */
/*     return; */
/* } */

/* /\* handle recving ack *\/ */
/* void handle_ack_event( */
/*     datanode_state * ns, */
/*     tw_bf * b, */
/*     mr_msg * m, */
/*     tw_lp * lp) */
/* { */
/*     mr_msg * m_local = malloc(sizeof(mr_msg)); */
/*     mr_msg * m_remote = malloc(sizeof(mr_msg)); */

/* //    m_local->mr_event_type = MR_REQ; */
/*     m_local->mr_event_type = MR_LOCAL; */
/*     m_local->src = lp->gid; */

/*     memcpy(m_remote, m_local, sizeof(mr_msg)); */
/*     m_remote->mr_event_type = MR_REQ; */

/* //    printf("handle_ack_event(), lp %llu.\n", (unsigned long long)lp->gid); */

/*     /\* safety check that this request got to the right server *\/ */
/* //    printf("\n m->src %d lp->gid %d ", m->src, lp->gid); */
/*     int opt_offset = 0; */
/*     if(net_id == DRAGONFLY && lp->gid % 5) */
/* 	 opt_offset = 3; */

/*     assert(m->src == (lp->gid + offset + opt_offset)%(num_datanode*2 + num_routers)); */

/*     if(ns->msg_sent_count < NUM_REQS) */
/*     { */
/*         /\* send another request *\/ */
/* 	model_net_event(net_id, "test", m->src, PAYLOAD_SZ, sizeof(mr_msg), (const void*)m_remote, sizeof(mr_msg), (const void*)m_local, lp); */
/*         ns->msg_sent_count++; */
/*         m->incremented_flag = 1; */
/*     } */
/*     else */
/*     { */
/*         m->incremented_flag = 0; */
/*     } */

/*     return; */
/* } */

/* /\* handle receiving request *\/ */
/* void handle_req_event( */
/*     datanode_state * ns, */
/*     tw_bf * b, */
/*     mr_msg * m, */
/*     tw_lp * lp) */
/* { */
/*     mr_msg * m_local = malloc(sizeof(mr_msg)); */
/*     mr_msg * m_remote = malloc(sizeof(mr_msg)); */

/*     m_local->mr_event_type = MR_LOCAL; */
/*     m_local->src = lp->gid; */

/*     memcpy(m_remote, m_local, sizeof(mr_msg)); */
/*     m_remote->mr_event_type = MR_ACK; */
/*     //printf("handle_req_event(), lp %llu src %llu .\n", (unsigned long long)lp->gid, (unsigned long long) m->src); */

/*     /\* safety check that this request got to the right server *\/ */
/* //    printf("\n m->src %d lp->gid %d ", m->src, lp->gid); */
/*     int opt_offset = 0; */
/*     if(net_id == DRAGONFLY && (m->src % 5)) */
/* 	  opt_offset = 3; /\* optional offset due to dragonfly mapping *\/ */
    
/*     assert(lp->gid == (m->src + offset + opt_offset)%(num_datanode*2 + num_routers)); */
/*     ns->msg_recvd_count++; */

/*     /\* send ack back *\/ */
/*     /\* simulated payload of 1 MiB *\/ */
/*     /\* also trigger a local event for completion of payload msg *\/ */
/*     /\* remote host will get an ack event *\/ */
   
/*    // mm Q: What should be the size of an ack message? may be a few bytes? or larger..?  */
/*     model_net_event(net_id, "test", m->src, PAYLOAD_SZ, sizeof(mr_msg), (const void*)m_remote, sizeof(mr_msg), (const void*)m_local, lp); */
/* //    printf("\n Sending ack to LP %d %d ", m->src, m_remote->src); */
/*     return; */
/* } */
