#ifndef MR_EVENT_H
#define MR_EVENT_H

/* 
 * types of events that will constitute MapReduce and HDFS requests
 * will add more, schedule layer, apps layer etc.
 * unify event space
 */
enum mr_event
  {
    MR_KICKOFF=14,    /* initial event */
    
    // map reduce event
    MR_ASSIGN_MAP_TASK,
    MR_RECV_MAP_TASK,
    MR_ASSIGN_REDUCE_TASK,
    MR_RECV_REDUCE_TASK,

    MR_HEART_BEAT,
    MR_RECV_HEART_BEAT,
    MR_SCHEDULE,
    MR_BLOCK_POS_QUERY,
    MR_RECV_BLOCK_POS_QUERY,

    MR_ACK_BLOCK_POS_QUERY,
    MR_GET_DATA_BLOCK,  // local
    MR_FETCH_DATA_BLOCK, // remote
    MR_REDUCER_COMPUTE,
    MR_MAPPER_COMPUTER,
    MR_PROCESS_GET_DATA_BLOCK,
    MR_GET_DATA_BLOCK_BACK,

    MR_START_MAP_TASK,
    MR_FINISH_MAP_TASK,
    MR_START_REDUCE_TASK,
    MR_FINISH_REDUCE_TASK,

    MR_GET_INTER_DATA,
    MR_GET_INTER_DATA_BACK,
    // map reduce event end

    MR_REQ,        /* request event */
    MR_ACK,        /* ack event */
    MR_LOCAL       /* local event */
  };


#endif
