#ifndef MR_EXTERN_H
#define MR_EXTERN_H

#include <ross.h>
#include "mr-types.h"
#include "mr-config.h" 
#include "mr-event.h"

#define NUM_REQS 5  /* number of requests sent by each server */
#define PAYLOAD_SZ 2048 /* size of simulated data payload, bytes  */

extern int net_id;
extern int num_routers;
extern int num_task_tracker;
extern int num_datanode;
extern int offset;
extern int num_tt_per_group;// task tracker per group
extern int num_dn_per_group;// namenode per group
extern int num_tm_per_group;// terminal per group

extern int NAMENODE_POS;

extern void
outputSlotMap( int * );

extern void
outputScheduleMap( tw_lpid ** );

extern int 
getLocalDatanode( int );

extern int 
getLocalTaskTracker( int );

extern int 
isInSameNode( int, 
	      int );


extern void 
scheduleMapTask( int * , 
		 mrJob, 
		 tw_lpid **,
		 int );

extern void 
scheduleReduceTask( tw_lpid *, 
		    int * );

extern void 
handle_start_reduce_task_event( task_tracker_state * ns,
				tw_bf * b,
				mr_msg * m,
				tw_lp * lp);

extern void 
handle_start_reduce_task_event_rc( task_tracker_state * ns,
				   tw_bf * b,
				   mr_msg * m,
				   tw_lp * lp);

extern void
handle_get_inter_data_back_event( task_tracker_state * ns,
				  tw_bf * b,
				  mr_msg * m,
				  tw_lp * lp);


extern void
handle_get_inter_data_back_event_rc( task_tracker_state * ns,
				     tw_bf * b,
				     mr_msg * m,
				     tw_lp * lp);


extern void 
handle_finish_reduce_task_event( task_tracker_state * ns,
				 tw_bf * b,
				 mr_msg * m,
				 tw_lp * lp);

extern void 
handle_finish_reduce_task_event_rc( task_tracker_state * ns,
				    tw_bf * b,
				    mr_msg * m,
				    tw_lp * lp);

extern void 
handle_finish_map_task_event_rc( task_tracker_state * ns,
				 tw_bf * b,
				 mr_msg * m,
				 tw_lp * lp);

extern void 
handle_finish_map_task_event( task_tracker_state * ns,
			      tw_bf * b,
			      mr_msg * m,
			      tw_lp * lp);

extern void 
handle_start_map_task_event_rc( task_tracker_state * ns,
				tw_bf * b,
				mr_msg * m,
				tw_lp * lp);

extern void 
handle_start_map_task_event( task_tracker_state * ns,
			     tw_bf * b,
			     mr_msg * m,
			     tw_lp * lp);

extern void 
handle_get_data_block_back_event_rc( task_tracker_state * ns,
				     tw_bf * b,
				     mr_msg * m,
				     tw_lp * lp);

extern void 
handle_get_data_block_back_event( task_tracker_state * ns,
				  tw_bf * b,
				  mr_msg * m,
				  tw_lp * lp);

extern void 
handle_get_inter_data_event( datanode_state * ns,
			     tw_bf * b,
			     mr_msg * m,
			     tw_lp * lp);

extern void 
handle_get_inter_data_event_rc( datanode_state * ns,
				tw_bf * b,
				mr_msg * m,
				tw_lp * lp);


extern void 
handle_process_get_data_block_event( datanode_state * ns,
				     tw_bf * b,
				     mr_msg * m,
				     tw_lp * lp);

extern void 
handle_process_get_data_block_event_rc( datanode_state * ns,
					tw_bf * b,
					mr_msg * m,
					tw_lp * lp);
  

extern void 
handle_recv_block_pos_query_event( datanode_state * ns,
				   tw_bf * b,
				   mr_msg * m,
				   tw_lp * lp);

extern void 
handle_recv_block_pos_query_event_rc( datanode_state * ns,
				      tw_bf * b,
				      mr_msg * m,
				      tw_lp * lp);

// map-event.c externs
extern void 
handle_get_data_block_event( task_tracker_state * ns,
			     tw_bf * b,
			     mr_msg * m,
			     tw_lp * lp);

extern void 
handle_ack_block_pos_query_event( task_tracker_state * ns,
				  tw_bf * b,
				  mr_msg * m,
				  tw_lp * lp);

extern void 
handle_block_pos_query_event( task_tracker_state * ns,
			      tw_bf * b,
			      mr_msg * m,
			      tw_lp * lp);

extern void 
handle_recv_map_task_event( task_tracker_state * ns,
			    tw_bf * b,
			    mr_msg * m,
			    tw_lp * lp);

extern void 
handle_assign_map_task_event( task_tracker_state * ns,
			      tw_bf * b,
			      mr_msg * m,
			      tw_lp * lp);

extern void 
handle_schedule_event( task_tracker_state * ns,
		       tw_bf * b,
		       mr_msg * m,
		       tw_lp * lp);

extern void handle_heartbeat_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_heartbeat_recv_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_kickoff_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_ack_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_req_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_local_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_get_data_block_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_ack_block_pos_query_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_block_pos_query_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_recv_map_task_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_assign_map_task_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_schedule_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_heartbeat_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_heartbeat_recv_event_rc(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);

extern void handle_local_rev_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
   tw_lp * lp);
extern void handle_kickoff_rev_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_ack_rev_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);
extern void handle_req_rev_event(
    task_tracker_state * ns,
    tw_bf * b,
    mr_msg * m,
    tw_lp * lp);



// reduce.c externs
extern void handle_reduce_compute_event(task_tracker_state* , tw_bf* , mr_msg* , tw_lp* );
extern void handle_reduce_compute_event_rc(task_tracker_state* , tw_bf* , mr_msg* , tw_lp* );

// should be interface in future and let each network implement it
extern int taskTrackerGlobalToLocal(int);
extern int taskTrackerLocalToGlobal(int);
extern int datanodeGlobalToLocal(int);
extern int datanodeLocalToGlobal(int);

extern void job_tracker_init(job_tracker_state* ,  tw_lp* );
extern void job_tracker_eventHandler(job_tracker_state* , tw_bf* , mr_msg* , tw_lp* );
extern void job_tracker_eventHandler_rc(job_tracker_state* , tw_bf* , mr_msg* , tw_lp* );
extern void job_tracker_finish(job_tracker_state* , tw_lp* );

extern void task_tracker_init(task_tracker_state* ,  tw_lp* );
extern void task_tracker_eventHandler(task_tracker_state* , tw_bf* , mr_msg* , tw_lp* );
extern void task_tracker_eventHandler_rc(task_tracker_state* , tw_bf* , mr_msg* , tw_lp* );
extern void task_tracker_finish(task_tracker_state* , tw_lp* );

extern void namenode_init(namenode_state* ,  tw_lp* );
extern void namenode_eventHandler(namenode_state* , tw_bf* , mr_msg* , tw_lp* );
extern void namenode_eventHandler_rc(namenode_state* , tw_bf* , mr_msg* , tw_lp* );
extern void namenode_finish(namenode_state* , tw_lp* );

extern void datanode_init(datanode_state* ,  tw_lp* );
extern void datanode_eventHandler(datanode_state* , tw_bf* , mr_msg* , tw_lp* );
extern void datanode_eventHandler_rc(datanode_state* , tw_bf* , mr_msg* , tw_lp* );
extern void datanode_finish(datanode_state* , tw_lp* );

#endif
