#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "greedyVC.h"

int main()
{
  int i,j,k;
  int timeSlot[N_process][N_time];
  int N_breaks[N_process];

  for (i=0;i<N_process;i++)
    for (j=0;j<N_time;j++)
      timeSlot[i][j]=1;

  for (i=0;i<N_process;i++)
    {
      for (j=0;j<N_time;j++)
	printf("%d",timeSlot[i][j]);
      printf("\n");
    }

  // random breaking
  srand (time(NULL));
  for (i=0;i<N_process;i++)
    {
      N_breaks[i] = rand() % 6 + 3;
      printf("number of breaks for node %d is %d\n",i,N_breaks[i]);
    }

  // get real breaking points for each process
  int * breaks[N_process];
  int flag = 1;
  int rValue;
  for (i=0;i<N_process;i++)
    breaks[i] = (int *)malloc(sizeof(int)*N_breaks[i]);

  // add head and tail breaks
  for (i=0;i<N_process;i++)
    {
      breaks[i][0] = 0;
      breaks[i][N_breaks[i]-1] = N_time - 1;
    }

  for (i=0;i<N_process;i++)
    {
      printf("break point for process[%d] is ",i);
      for (j=1;j<N_breaks[i]-1;j++)
	{
	  // generate non-repeating break points
	  while(flag)
	    {
	      flag = 0;
	      rValue = rand() % ( N_time-1 );
	      for (k=0;k<j;k++)
		if (rValue == breaks[i][k])
		  flag = 1;
	      breaks[i][j] = rValue;
	    }
	  flag = 1;
	  printf(" %d",breaks[i][j]);
	}
      printf("\n");
    }


  // sort break points  
  int temp;
  for (i=0;i<N_process;i++)
    {
      for (j=0;j<N_breaks[i];j++)
	{
	  for (k=1;k<N_breaks[i];k++)
	    {
	      if ( breaks[i][k-1] > breaks[i][k] )
		{
		  temp = breaks[i][k-1];
		  breaks[i][k-1] = breaks[i][k];
		  breaks[i][k] = temp;
		}
	    }
	}
    }

  // print after sort
  printf("\n after sort \n");
  for (i=0;i<N_process;i++)
    {
      printf("break point for process[%d] is ",i);
      for (j=0;j<N_breaks[i];j++)
	{
	  printf(" %d",breaks[i][j]);
	}
      printf("\n");
    }

  // flip 1s and make map
  printf("\n availability map \n");
  for (i=0;i<N_process;i++)
    {
      rValue = 1;
      for (j=1;j<N_breaks[i];j++)
	{
	  for (k=breaks[i][j-1];k<breaks[i][j];k++)
	    {
	      //printf("breaks[%d][%d] is %d rValue is %d\n",i,j-1,breaks[i][j-1],rValue);
	      timeSlot[i][k] = rValue;
	    }
	  rValue = 1 - rValue;
	}
    }

  // output map
  printf("\n Output map after it is done\n");
  for (i=0;i<N_process;i++)
    {
      for (j=0;j<N_time;j++)
	printf("%d",timeSlot[i][j]);
      printf("\n");
    }

  FILE * pFile;
  pFile = fopen ("map.txt","w");

  for (i=0;i<N_process;i++)
    {
      for (j=0;j<N_time;j++)
	fprintf(pFile, "%d\n",timeSlot[i][j]);
      //fprintf(pFile, "\n");
    }

  fclose (pFile);

  // free
  for (i=0;i<N_process;i++)
    free(breaks[i]);
  return 0;
}
