#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "greedyVC.h"

int timeSlot[N_process][N_time];

void outputArray(int * array, int size)
{
  int i;
  for (i=0;i<size;i++)
    printf("%d ",array[i]);
  printf("\n");
}

void resetArray(int * array, int size)
{
  int i;
  for (i=0;i<size;i++)
    array[i] = 0;
}

int checkFull(int * array, int size)
{// return 1 if full, otherwise 0
  int flag = 1, i;
  for (i=0;i<size;i++)
    if (array[i]<N_REP)
      flag = 0;
  return flag;
}

int getCoveredElementNum(int * covered_array, 
			 int * input_array)
{
  int count=0, j;
  for (j=0;j<N_time;j++)
    {
      if ( (covered_array[j]<N_REP) && (input_array[j]==1))
	count++;
    }
  return count;
}

// this only returns the found index of the max cover node
int getOneBatch(int * available_set, int * covered_set )
{
  int index = NO_MORE_NODE, tempCount = 0, elementCount, i;
  for (i=0;i<N_process;i++)
    {
      if (available_set[i] == 1) // check availability
	elementCount = getCoveredElementNum(covered_set,timeSlot[i]);
      else
	elementCount = 0;

      if (elementCount > tempCount)
	{
	  tempCount = elementCount;
	  index = i; 
	}
    }// found one

  // update avail set and cover set
  if ( index >= 0 )
    {
      available_set[index] = 0;
      for (i=0;i<N_time;i++)
	covered_set[i] += timeSlot[index][i];
    }  

  return index;
}

int main()
{
  int i,j;
  //int timeSlot[N_process][N_time];

  // random breaking
  srand (time(NULL));

  for (i=0;i<N_process;i++)
    for (j=0;j<N_time;j++)
      timeSlot[i][j]=1;

  FILE * pFile;
  pFile = fopen ("map.txt","r");
  
  for (i=0;i<N_process;i++)
    for (j=0;j<N_time;j++)
      fscanf(pFile, "%d", &timeSlot[i][j]);
  
  fclose (pFile);

  // output map
  printf("\n Output map after it is done\n");
  for (i=0;i<N_process;i++)
    {
      printf("line %5d: ",i);
      for (j=0;j<N_time;j++)
	printf("%d",timeSlot[i][j]);
      printf("\n");
    }

  // greedy algorithm
  int available_set[N_process], covered_set[N_time];
  int index, elementCount, tempCount, flag, foundCount, goOut;
  int savedIndex[N_blocks][N_copy];
  int savedTotalNumOfCopy[N_blocks];
  int savedNumberOfBlockPerNode[N_process];

  for (i=0;i<N_blocks;i++)
    for (j=0;j<N_copy;j++)
      savedIndex[i][j] = -1;

  for (i=0;i<N_process;i++)
    available_set[i] = 1;

  for (j=0;j<N_time;j++)
    covered_set[j] = 0;

  for (i=0;i<N_process;i++)
    printf("line %-5d covered element is %d\n",
	   i,
	   getCoveredElementNum(covered_set,timeSlot[i]));

  goOut = 0;

  for (i=0;i<N_blocks;i++)
    {
      //if (goOut==1)
      //break;
      printf("Here is %d\n",i);

      flag = 0;
      foundCount = 0;

      while(!flag)
	{
	  if (foundCount==0)
	    index = rand() % N_process;
	  else
	    index = getOneBatch( available_set, covered_set );  
	  
	  if (index==NO_MORE_NODE)
	    {
	      //printf("No more available\n");
	      goOut=1;

	      // start new search, every node is available again
	      for (j=0;j<N_process;j++)
		available_set[j] = 1;

	      break;
	    }

	  //printf("index is %d\n",index);
	  //outputArray(covered_set, N_time);
	  flag = checkFull(covered_set, N_time);
	  
	  savedIndex[i][foundCount]=index;
	  foundCount++;

	}
      savedTotalNumOfCopy[i]=foundCount;

      for (j=0;j<N_time;j++)
	covered_set[j] = 0;

      //outputArray(savedIndex[i], N_process);
    }

  int totalNum=0;
  // calculate stastics
  for (j=0;j<N_blocks;j++)
    totalNum += savedTotalNumOfCopy[j];

  printf("\n \t for %d copy guarantee average number of copies is %f\n",
	 N_REP,
	 (totalNum*1.0)/N_blocks);

  // calculate the number of blocks in each node
  for (i=0;i<N_blocks;i++)
    for (j=0;j<N_copy;j++)
      {
	if (savedIndex[i][j]>=0)
	  savedNumberOfBlockPerNode[savedIndex[i][j]]++;
      }

  outputArray(savedNumberOfBlockPerNode, N_process);

  return 0;
}
